#include "fun.h"

int mu2lin(unsigned char b)
{
    int mu = b ^ 0xFF; // bit flipping
    int s = (mu & 0x80) >> 7 ; // X------- sign bit
    int e = (mu & 0x70) >> 4 ; // -XXX---- exponent
    int f = (mu & 0x0F) >> 0 ; // ----XXXX mantissa
    int lin = (f << (e+1)) - 32 + (32 << e);
    return s ? -lin : lin;
}
unsigned char lin2mu(int lin)
{
    int e=0, s=1, f=0; // f=0 suspends a warning
    for((s=(lin<0))?lin=-lin:0; e<8; e++)
    {
        f = ((lin+32) >> (e+1)) - 16;
        if(f<16)break;
    }
    return ((s<<7) | (e<<4) | f) ^ 255;
}
