#ifndef voicebox_stream_hh
#define voicebox_stream_hh

#include <string>

// Undefine stdio macro.
#undef getc

// I tried to implement this as an descendant
// of filebuf or iostream or similar, but it
// seems like those classes aren't device-friendly.
// Instead of trying to read with read(), they
// try _llseek() and get an error and cease trying.
// So I made this myself.       // Bisqwit

class customstream
{
protected:
	int fd;
	char getcbuf[512];
	int getcptr, getclen;
public:
	customstream() : fd(-1), getcptr(0), getclen(0) { }
	customstream(int fde) : fd(fde), getcptr(0), getclen(0) { }
	char getc();
	int sendah(const string &s);
	string &getline(string &s);
    void close();
};

#endif
